
INFINITY = "+inf"
MINUS_INFINITY = "-inf"


def error(string):
    print(string)
    exit(1)
    assert False
    return


def cmp_to_key(mycmp):
    'Convert a cmp= function into a key= function'
    class K(object):
        def __init__(self, obj, *args):
            self.obj = obj
        def __lt__(self, other):
            return mycmp(self.obj, other.obj) < 0
        def __gt__(self, other):
            return mycmp(self.obj, other.obj) > 0
        def __eq__(self, other):
            return mycmp(self.obj, other.obj) == 0
        def __le__(self, other):
            return mycmp(self.obj, other.obj) <= 0  
        def __ge__(self, other):
            return mycmp(self.obj, other.obj) >= 0
        def __ne__(self, other):
            return mycmp(self.obj, other.obj) != 0
    return K


__is_py_v2 = None
def isPython2():
    global __is_py_v2
    if __is_py_v2 is None:
        import sys
        __is_py_v2 = sys.version_info[:2] < (3, 0)
    return __is_py_v2


def convertString(string):
    res = None
    if isPython2():
        res = string.decode("utf-8")
    else:
        res = str(string, "utf-8")
    return res 


def toBytes(string):
    if isPython2():
        return string
    else:
        return bytes(string, "utf-8")


def getIOBuffer():
    if isPython2():
        import StringIO
        return StringIO.StringIO()
    else:
        import io
        return io.BytesIO()


# Base class for pseudo enumeratives
class Enum(object):

    def getAllValues(self):
        res = []
        for (k,v) in self.__dict__.items():
            if not k.startswith("_"):
                res.append(v)
        return res

    pass


def c_mul(a, b):
    return eval(hex((a * b) & 0xFFFFFFFF)[:-1])


def testBit(int_type, offset):
    mask = 1 << offset
    return(int_type & mask)
