from formula import *


class Walker(object):
    
    def __init__(self):
        return

    
    def walk(self, formula):
        if formula.nodeType == FNode.AND:
            self.walkAnd(formula)
        elif formula.nodeType == FNode.OR:
            self.walkOr(formula)
        elif formula.nodeType == FNode.NOT:
            self.walkNot(formula)
        elif formula.nodeType == FNode.SYMBOL:
            self.walkSymbol(formula)
        elif formula.nodeType == FNode.EQUALS:
            self.walkEquals(formula)
        elif formula.nodeType == FNode.GE:
            self.walkGe(formula)
        elif formula.nodeType == FNode.LE:
            self.walkLe(formula)
        elif formula.nodeType == FNode.GT:
            self.walkGt(formula)
        elif formula.nodeType == FNode.LT:
            self.walkLt(formula)
        elif formula.nodeType == FNode.CONSTANT:
            self.walkConst(formula)
        elif formula.nodeType == FNode.BCONSTANT:
            self.walkBConst(formula)
        elif formula.nodeType == FNode.FORALL:
            self.walkForall(formula)
        elif formula.nodeType == FNode.EXISTS:
            self.walkExists(formula)
        elif formula.nodeType == FNode.DEFINITION:
            self.walkDefinition(formula)
        elif formula.nodeType == FNode.PLUS:
            self.walkPlus(formula)
        elif formula.nodeType == FNode.MINUS:
            self.walkMinus(formula)
        elif formula.nodeType == FNode.TIMES:
            self.walkTimes(formula)
        elif formula.nodeType == FNode.DIV:
            self.walkDiv(formula)
        elif formula.nodeType == FNode.FUNCTION:
            self.walkFunction(formula)
        elif formula.nodeType == FNode.TEXTFORMULA:
            self.walkTextFormula(formula)

        else:
            assert False
        return
        

    def walkTextFormula(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkPlus(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkTimes(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return
    
    def walkDiv(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return
    
    def walkFunction(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkMinus(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkAnd(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return
    
    def walkOr(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkNot(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkSymbol(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkGe(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkLe(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return
    
    def walkEquals(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkGt(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkLt(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkConst(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkBConst(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkForall(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkExists(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return

    def walkDefinition(self, formula):
        for s in formula.getSons():
            self.walk(s)
        return
    pass
